#!/usr/bin/perl
#
#   parse.pl
#   (C) 2008 Zelgadiss
#

use XML::DOM;
#use Encode;
#use encoding 'utf-8';

my $debug = 0;

my %psymbol_table_pre = (
    '\x7c' => '{hc-p-u-ca8a}',       # :? [ca8a]
    '\x3a' => '{hc-p-u-3a}',       # : [cb90]
    '\x3b' => '{hc-p-u-cb8c}',     # t̓_ ANZgp
    '\x22' => '{hc-p-u-cb88}',     # t̓_ ANZgp
    );
my %psymbol_table = (
    '\xc3\x81' => '{hc-p-u-c381}',  # A  :?? i㉺ɕׂj
    '\xc3\x82' => '{hc-p-u-c382}',  # A  :?? i㉺ɕׂj
    '\xc3\x8a' => '{hc-pi-u-c999}',  # E  :?̃C^bN [c999]
    '\xc3\x90' => '{hc-p-u-ca83}',  # D  :? [ca83]
    '\xc3\x98' => '{hc-p-u-ceb8}', # O  : [ceb8]
    '\xc3\xa1' => '{hc-p-u-c3a1}',  # ||
    '\xc3\x98' => '{hc-p-u-ceb8}', # : [ceb8]
    '\xc3\xa3' => '{hc-p-u-c992}',  # :? [c992]
    '\xc3\xa4' => '{hc-p-u-c991}',  # :? [c991]
    '\xc3\xa9' => '{hc-p-u-c994}',  # :? [c994]
    '\xc3\xae' => '{hc-p-u-c99c}',  # :?  [c99c]
    '\xc3\xbb' => '{hc-p-u-c9aa}',  # :? [c9aa]
    '\xc3\xa6' => '{hc-p-u-c3a6}', # :a [c3a6]
    '\xc3\xab' => '{hc-p-u-c999}',  # :? [c999]
    '\xc5\xa1' => '{hc-p-u-ca8c}',  # :? [ca8c]
    '\xc5\xbe' => '{hc-p-u-ca92}',  # :? [ca92]
    '\xca\x8c' => '{hc-p-u-ca8c}',  # ?
    '\xc3\xb0' => '{hc-p-u-c3b0}',  # d
#    '\xc3\x85' => '{hc-p-u-c58b}',  # ?
#    '\xc3\x83' => '{hc-p-u-c3b0}',  # d
    );
my %symbol_table = (
    '\xe2\x80\xa7' => '{fc-u-e280a7}',  # E
    '\xe2\x86\xaa' => '{fc-u-e286aa}', # Ȃ
    '\xe2\x9e\x94' => '{fc-u-e29e94}', # 
#    '\xc3\x80' => '{fc-u-c380}',  # A
    '\xc3\x81' => '{hc-u-c381}',  # A  :?? i㉺ɕׂj
    '\xc3\x82' => '{hc-u-c382}',  # A  :?? i㉺ɕׂj
#    '\xc3\x83' => '{fc-u-c383}',  # A
#    '\xc3\x84' => '{fc-u-c384}',  # A
    '\xc3\x85' => '{hc-u-c58b}',  # A  :? [c58b]
    '\xc3\x89' => '{hc-u-c389}',  # E  :E [c389]
    '\xc3\x8a' => '{hc-u-c38a}',  # E  :?̃C^bN [c999]
    '\xc3\x90' => '{hc-u-c390}',  # D  :? [ca83]
    '\xc3\x97' => '{fc-u-c397}',  # ~
    '\xc3\x98' => '{hc-u-c398}', # O  : [ceb8]
    '\xc3\xa0' => '{hc-u-c3a0}',  # a  :a [c3a0]
    '\xc3\xa1' => '{hc-u-c3a1}',  # :a [c3a1]
    '\xc3\xa2' => '{hc-u-c3a2}',  # :a [c3a2]
    '\xc3\xa3' => '{hc-u-c3a3}',  # a  :? [c992]
    '\xc3\xa4' => '{hc-u-c3a4}',  # a  :? [c991]
#    '\xc3\xa5' => '{hc-u-c991}',  # a  :? [c991]
    '\xc3\xa8' => '{hc-u-c3a8}',  # :  [c3a8]
    '\xc3\xa9' => '{hc-u-c3a9}',  # e  :e [c3a9]
    '\xc3\xaa' => '{hc-u-c3aa}', # :e [c3aa]
    '\xc3\xad' => '{hc-u-c3ad}',  # :i [c3ad]
    '\xc3\xaf' => '{hc-u-c3af}',  # :  [c3af]
    '\xc3\xae' => '{hc-u-c99c}',  # :? [c99c]
    '\xc3\xb1' => '{hc-u-c3b1}',  # :n [c3b1]
    '\xc3\xb3' => '{hc-u-c3b3}',  # :o [c3b3]
    '\xc3\xbb' => '{hc-u-c3bb}',  # 
    '\xc3\xa6' => '{hc-u-c3a6}', # :a [c3a6]
    '\xc3\xab' => '{hc-u-c999}',  # e  :? [c999]
    '\xc5\xa1' => '{hc-u-ca8c}',  # s  :? [ca8c]
    '\xc5\xbe' => '{hc-u-ca92}',  # ? z  :? [ca92]
    '\xc5\x8b' => '{hc-u-c58b}',  # :? [c58b]
    '\xc5\x99' => '{hc-u-c599}',  # ? [c599]
    '\xc5\x9f' => '{hc-u-c59f}',  # ? [c59f]
    '\xc2\xa0' => '{hc-u-c2a0}',   # ̕R[h SpXy[XH
    '\xc2\xa3' => '{hc-u-c2a3}',  # 
    '\xca\x8a' => '{hc-u-ca8c}',   # ?
    '\xe2\x80\xa2' => '{fc-u-e280a2}', # E
    '\xe2\x80\x94' => '{fc-u-e28094}', # |iSp}CiXj
    '\xca\x8c' => '{hc-u-ca8c}', # ?
    '\xcb\x8c' => '{hc-u-cb8c}',   # t̓_iANZgpHj
    '\xcb\x88' => '{hc-u-cb88}',   # t̓_iANZgpHj
    '\xcb\x90' => '{hc-u-cb90}',   # Eip̓_j
#    '\xe2\x82\x82' => '<sub>2</sub>', # t2
    '\xe2\x89\xa0' => '{fc-u-e289a0}',  # 
    '\xe2\x86\x94' => '{fc-u-e28694}', # <->
    '\xe2\x84\xa2' => '{fc-u-e284a2}', # ?
    '\xe2\x9c\x93' => '{fc-u-e29c93}', # ?
    '\xe3\x80\x83' => '{fc-u-e38083}', # V
    '\xee\x80\x95' => '{fc-u-ee8095}', # E
    '\xcf\x80' => '{fc-u-cf80}',   # 
    '\xc9\x92' => '{fc-u-c992}', # ?
    '\xc9\x99' => '{hc-u-c999}', # etɂȂ
    '\xe2\x82\x82' => '<sub>2</sub>', # t2
    '\x20' => '{hc-u-20}',      # pXy[X
#    "'" => "f",  # p'Sp
#    ',' => 'C',  # p,Sp
    );

my %symbol_search_word = (
    '\xe2\x80\xa7' => '{fc-u-e280a7}',  # E
    '\xe2\x86\xaa' => '{fc-u-e286aa}', # Ȃ
    '\xe2\x9e\x94' => '{fc-u-e29e94}', # 
#    '\xc3\x80' => '{fc-u-c380}',  # A
    '\xc3\x81' => '{hc-u-c381}',  # A  :?? i㉺ɕׂj
    '\xc3\x82' => '{hc-u-c382}',  # A  :?? i㉺ɕׂj
#    '\xc3\x83' => '{fc-u-c383}',  # A
#    '\xc3\x84' => '{fc-u-c384}',  # A
    '\xc3\x85' => '{hc-u-c58b}',  # A  :? [c58b]
    '\xc3\x89' => '{hc-u-c389}',  # E  :E [c389]
    '\xc3\x8a' => '{hc-u-c38a}',  # E  :?̃C^bN [c999]
    '\xc3\x90' => '{hc-u-c390}',  # D  :? [ca83]
    '\xc3\x97' => '{fc-u-c397}',  # ~
    '\xc3\x98' => '{hc-u-c398}', # O  : [ceb8]
    '\xc3\xa0' => 'a',  # a  :a [c3a0]
    '\xc3\xa1' => 'a',  # :a [c3a1]
    '\xc3\xa2' => 'a',  # :a [c3a2]
    '\xc3\xa3' => '{hc-u-c3a3}',  # a  :? [c992]
    '\xc3\xa4' => '{hc-u-c3a4}',  # a  :? [c991]
#    '\xc3\xa5' => '{hc-u-c991}',  # a  :? [c991]
    '\xc3\xa8' => 'e',  # :  [c3a8]
    '\xc3\xa9' => 'e',  # e  :e [c3a9]
    '\xc3\xaa' => 'e', # :e [c3aa]
    '\xc3\xad' => 'i',  # :i [c3ad]
    '\xc3\xaf' => 'i',  # :  [c3af]
    '\xc3\xae' => '{hc-u-c99c}',  # :? [c99c]
    '\xc3\xb1' => '{hc-u-c3b1}',  # :n [c3b1]
    '\xc3\xb3' => '{hc-u-c3b3}',  # :o [c3b3]
    '\xc3\xbb' => '{hc-u-c3bb}',  # 
    '\xc3\xa6' => '{hc-u-c3a6}', # :a [c3a6]
    '\xc3\xab' => '{hc-u-c999}',  # e  :? [c999]
    '\xc5\xa1' => '{hc-u-ca8c}',  # s  :? [ca8c]
    '\xc5\xbe' => '{hc-u-ca92}',  # ? z  :? [ca92]
    '\xc5\x8b' => '{hc-u-c58b}',  # :? [c58b]
    '\xc5\x99' => '{hc-u-c599}',  # ? [c599]
    '\xc5\x9f' => '{hc-u-c59f}',  # ? [c59f]
    '\xc2\xa0' => '{hc-u-c2a0}',   # ̕R[h SpXy[XH
    '\xc2\xa3' => '{hc-u-c2a3}',  # 
    '\xca\x8a' => '{hc-u-ca8c}',   # ?
    '\xe2\x80\xa2' => '{fc-u-e280a2}', # E
    '\xe2\x80\x94' => '{fc-u-e28094}', # |iSp}CiXj
    '\xca\x8c' => '{hc-u-ca8c}', # ?
    '\xcb\x8c' => '{hc-u-cb8c}',   # t̓_iANZgpHj
    '\xcb\x88' => '{hc-u-cb88}',   # t̓_iANZgpHj
    '\xcb\x90' => '{hc-u-cb90}',   # Eip̓_j
#    '\xe2\x82\x82' => '<sub>2</sub>', # t2
    '\xe2\x89\xa0' => '{fc-u-e289a0}',  # 
    '\xe2\x86\x94' => '{fc-u-e28694}', # <->
    '\xe2\x84\xa2' => '{fc-u-e284a2}', # ?
    '\xe2\x9c\x93' => '{fc-u-e29c93}', # ?
    '\xe3\x80\x83' => '{fc-u-e38083}', # V
    '\xee\x80\x95' => '{fc-u-ee8095}', # E
    '\xcf\x80' => '{fc-u-cf80}',   # 
    '\xc9\x92' => '{fc-u-c992}', # ?
    '\xc9\x99' => '{hc-u-c999}', # etɂȂ
    '\xe2\x82\x82' => '<sub>2</sub>', # t2
#    "'" => "f",  # p'Sp
#    ',' => 'C',  # p,Sp
    );


if (0) {
    $content = "";
    while (<>) {
        $content .= $_;
    }
    
    my($headword, $info) = get_content($content);
    print_debug($info);
    $info = replace_symbol($info);
    print $headword, "\n";
    print $info, "\n";

}

sub print_debug {
    my($str) = shift @_;

    my $cc = unpack("H*", $str);
    print "[$cc]\n";
}


sub get_content {
    my($content) = shift @_;
    
    #print $content;
    $content =~ s/\n//g;
    $content =~ s/\r//g;
    $content =~ s/<\?SK W\?>//g;
    $content =~ s/<\?SK \/W\?>//g;
    $content =~ s/<div class="endOfEntry"><\/div>//g;
    #@token = parse($content);

    $content = '<?xml version="1.0" encoding="utf-8"?>' . '<Entry>' . $content . '</Entry>';
    my $parser = new XML::DOM::Parser;
    my $doc;
    #print substr($content, 1739), "\n";
    #eval {
        $doc = $parser->parse($content);
    #};
    my $node = $doc->getFirstChild;

    my $headword = get_headword($doc);
    my $info = get_text($doc);

    $doc->dispose;

    return ($headword, $info);
}

sub get_headword {
    my($doc) = shift @_;
    my $node;
    my $node_name;
    my $item;

    my $headword = '';

    foreach $node ($doc->getChildNodes) {
        if ($node->getNodeType == ELEMENT_NODE) {
            $node_name = $node->getNodeName;
            if ($node_name eq 'div' && $node->getAttribute('class') eq 'woGroup') {
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'HWD') {
                $headword = $node->getFirstChild->getNodeValue;
                return $headword;
            }
            else {
                $headword = get_headword($node);
                if ($headword) {
                    return $headword;
                }
            }
        }
    }
    return $headword;
}

sub get_text {
    my($doc) = shift @_;
    my $node;
    my $node_name;
    my $item;

    my $text = '';

    my @nodes = $doc->getChildNodes;
    foreach $node ($doc->getChildNodes) {
        #$node = $doc->getFirstChild;
        #print $node->getNodeName, "\n";
        if ($node->getNodeType == ELEMENT_NODE) {
            #print $node->getNodeName, "\n";
            $node_name = $node->getNodeName;
            $item = $node->getAttribute('class');
            if ($node_name eq 'td' && $node->getAttribute('class') eq 'hdSel') {
                #$text = $text . get_text($node) . "\n";
                $text = $text . get_text($node) . "<br>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'HYPHENATION') {
                # nCtl[V̏
                #print "\n";
                $text = $text . get_text($node);
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'PronCodes') {
                #$text = $text . get_text($node) . "\n";
                $text = $text . replace_psymbol(get_text($node)) . "<br>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'GRAM') {
                # ZEZȂ
                #print "\n";
                $text = $text . get_text($node);
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'headwordSelected') {
                $text = $text . "<bd>" . get_text($node) . "</bd>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'homographsSelected') {
                $text = $text . "<bd><sup>" . get_text($node) . "</sup></bd>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'HOMNUM') {
                #get_text($node);
                #print "\n";
                $text = $text . "<sup>" . get_text($node) . "</sup>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'numsense') {
                #$text = $text . "\n" . get_text($node) . " ";
                $text = $text . "<br><bd>" . get_text($node) . "</bd> ";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'FIELD') {
                $text = $text . "[" .  get_text($node) . "]";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'REGISTERLAB') {
                #print "\n";
                $text = $text . get_text($node) . " ";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'DEF') {
                #$text = $text . "\n" . get_text($node);
                $text = $text . "<br>" . get_text($node);
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'GEO') {
                $text = $text . "[" . get_text($node) . "]";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'Variant') {
                #$text = $text . get_text($node) . "\n";
                $text = $text . get_text($node) . "<br>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'wordclassSelected') {
                my $wordclass = get_text($node);
                unless ($wordclass eq '') {
                    #$text = $text . " [" . get_text($node) . "]";
                    $text = $text . " <it>" . get_text($node) . "</it>";
                }
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'activebutton') {
                # \d̂Ŗ
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'activetitle') {
                $text = $text . "<br><br><bd>" . get_text($node) . "</bd>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'JOGHEADING') {
                $text = $text . "<bd>" . get_text($node) . "</bd>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'JOGHWD') {
                $text = $text . "<bd>" . get_text($node) . "</bd>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'CROSSREFTYPE') {
                $text = $text . get_text($node);
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'gramtitle2') {
                $text = $text . "<br><br><bd>" . get_text($node) . "</bd>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'HEAD2') {
                $text = $text . "<bd>" . get_text($node) . "</bd>";
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'UEXA') {
                $text = $text . "<br>" . get_text($node);
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'UsePara') {
                $text = $text . "<br>" . get_text($node);
            }
            elsif ($node_name eq 'span' && $node->getAttribute('class') eq 'UB') {
                $text = $text . "<bd>" . get_text($node) . "</bd>";
            }
            elsif ($node_name eq 'ftexa') {
                #$text = $text . "\n" . get_text($node);
                $text = $text . "<br>" . get_text($node);
            }
            elsif ($node_name eq 'div' && $node->getAttribute('class') eq 'woGroup') {
            }
            elsif ($node_name eq 'br') {
                $text = $text . "<br>";
            }
            elsif ($node_name eq 'xblbtnpron') {
            }
            elsif ($node_name eq 'xblkpron') {
            }
            elsif ($node_name eq 'xblspron') {
            }
            elsif ($node_name eq 'xblbtnentries') {
            }
            else {
                $text = $text . get_text($node);
            }
        }
        elsif ($node->getNodeType == ENTITY_NODE) {
            print $node->getNotationName, "\n";
        }
        elsif ($node->getNodeType == TEXT_NODE) {
            if ($node->getNodeValue =~ /\t+/) {
                $text = $text . ' ';
            }
            else {
                $text = $text . $node->getNodeValue;
            }
        }
        else {
            #print $node->getNodeValue, "\n";
        }
    }
    return $text;
}

sub parse {
    my($str) = shift @_;
    my @token;

    while ($str =~ /(([^<>]+)|(<.+?>))(.*)/) {
        if ($1 eq '<?SK W?>' || $1 eq '<?SK /W?>' ||
            tag_is($1, 'div') || tag_is($1, '/div') ||
            tag_is($1, 'tr') || tag_is($1, '/tr') ||
            tag_is($1, 'td') || tag_is($1, '/td')) {
        }
        else {
            print "[$1]\n";
            push(@token, $1);
        }
        $str = $4;
    }

    return @token;
}

sub tag_is {
    my($str, $tag) = @_;

    return $str =~ /<$tag ?(.*)>/
}

if ($debug) {
    open(LOGOUT, ">log.txt") || die "Could not open log.txt.\n";
}

sub replace_psymbol {
    my($str) = shift @_;
    my $key;

    utf8::encode($str);
    foreach $key (keys(%psymbol_table_pre)) {
        if ($str =~ /$key/) {
            $str =~ s/$key/$psymbol_table_pre{$key}/g;
            #print LOGOUT "----FOUND ($psymbol_table_pre{$key}) !----\n";
            #print LOGOUT $str, "\n";
        }
    }
    foreach $key (keys(%psymbol_table)) {
        if ($str =~ /$key/) {
            $str =~ s/$key/$psymbol_table{$key}/g;
            #print LOGOUT "----FOUND ($psymbol_table{$key}) !----\n";
            #print LOGOUT $str, "\n";
        }
    }
    utf8::decode($str);

    return $str;
}

sub replace_symbol {
    my($str) = shift @_;
    my $key;

    utf8::encode($str);
    foreach $key (keys(%symbol_table)) {
        if ($str =~ /$key/) {
            $str =~ s/$key/$symbol_table{$key}/g;
            #print LOGOUT "----FOUND ($symbol_table{$key}) !----\n";
            #print LOGOUT $str, "\n";
        }
    }

    return $str;
}

sub replace_symbol_search_word {
    my($str) = shift @_;
    my $key;

    utf8::encode($str);
    foreach $key (keys(%symbol_search_word)) {
        if ($str =~ /$key/) {
            $str =~ s/$key/$symbol_search_word{$key}/g;
            if ($debug) {
                print LOGOUT "----FOUND ($symbol_search_word{$key}) !----\n";
                print LOGOUT $str, "\n";
            }
        }
    }

    return $str;
}


1;
